;;; nastaveni promennych

smer		equ 21h
citani		equ 22h
rucniCitani	equ 23h
zTecka		equ 24h
blink		equ 25h
blinkState	equ 26h
motor		equ 27h

predvolba 	equ 50h
tmp 		equ 51h

tlac1		equ P0.2
tlac2		equ P0.3
dTlac1		equ P3.2
dTlac2		equ P3.3
tlacM1		equ P0.6
tlacM2		equ P0.7

; banka 0
zaklad 		equ R4
pocetRotaci	equ R2
pocetTlac2	equ R3
pocetDTlac1	equ R1

; banka 1
dispDesitky	equ P3.6
dispJednotky	equ P3.5
dispDesetiny	equ P3.4
dispInc		equ R2
desetiny		equ R3
jednotky		equ R4
desitky		equ R5
blinkInterval	equ R6

; banka 2
motorPocet	equ R2

	org 0h
	sjmp init ; skok na inicializaci mikroprocesoru

	org 0Bh
	ljmp cit0 ; preruseni pri preteceni citace/casovace 0
	
	org 1Bh
	ljmp cit1 ; preruseni pri preteceni citace/casovace 1

	org 30h

;;; kody cislic pro zobrazeni na displeji 

cislice:
	db 00010010b, 11010111b, 01001010b, 01000110b, 10000111b ; 0, 1, 2, 3, 4
	db 00100110b, 00100010b, 01010111b, 00000010b, 00000110b ; 5, 6, 7, 8, 9
pF:
	db 00101011b

;;; inicializace mikroprocesoru

	org 50h
init:
	clr RS1
	clr RS0

	mov SP, #0EFh
	mov zaklad, #01111111b
	mov A, zaklad

	mov R0, #1
	mov predvolba, #10

	clr smer
	clr citani
	clr zTecka
	setb rucniCitani
	clr blink
	clr blinkState
	clr motor

	mov pocetRotaci, #0
	mov pocetTlac2, #0
	mov pocetDTlac1, #1

	setb tlac1
	setb tlac2
	setb dTlac1
	setb dTlac2
	setb tlacM1
	setb tlacM2

	setb RS0
	mov desetiny, #0
	mov jednotky, #0
	mov desitky, #0
	mov DPTR, #cislice
	mov dispInc, #1
	mov blinkInterval, #80
	clr RS0

	mov 89h, #10001b
	mov TH0, #0
	mov TL0, #1
	setb EA
	setb ET0
	setb ET1
	setb TR0
	setb TR1

;;; hlavni smycka programu, zde probiha kontrola stisku tlacitek

program:
	jb tlac1, programTlac2 ; zpracovani stisku TL1 na zakladni desce

	lcall prPosunuti
	lcall prSrovnaniPozice

	lcall prSpozdeni
	
programTlac2:
	jb tlac2, programDTlac1 ; zpracovani stisku TL2 na zakladni desce
	lcall prTlac2
	lcall prSpozdeni

programDTlac1:
	jb dTlac1, programDTlac2 ; zpracovani stisku TL1 na desce s displeji
	lcall prDTlac1
	lcall prSpozdeni

programDTlac2:
	jb dTlac2, programTlacM1 ; zpracovani stisku TL2 na desce s displeji
	lcall prPrictiDisp
	lcall prSpozdeni
	
programTlacM1:
	jb tlacM1, programTlacM2 ; zpracovani stisku TL1 na desce s motorem
	setb motor ; povoli otaceni motoru
	lcall prSpozdeni

programTlacM2:
	jb tlacM2, program ; zpracovani stisku TL2 na desce s motorem
	clr motor ; zakaze otaceni motoru
	lcall prSpozdeni
	sjmp program

;;; preruseni citace/casovace 0
;;; posun rozsvycenych LED na portu P2

cit0:
	mov TH0, #03Ch
	mov TL0, #0AFh

	djnz R0, cit0Konec
	mov R0, predvolba
	
	mov P2, A
	jb smer, cit0Doprava
	rl A
	sjmp cit0Pokracuj
cit0Doprava:
	rr A

cit0Pokracuj:
	inc pocetRotaci
	cjne pocetRotaci, #9, cit0Konec
	mov pocetRotaci, #0

cit0Konec:
	reti

;;; preruseni citace/casovace 1
;;; zobrazovani na displeji
;;; otaceni krokoveho motoru

cit1:
	mov TH1, #0E7h
	mov TL1, #095h
	setb RS0 ; citac 1 pouziva druhou banku registru

	jnb blink, cit1Dale
	djnz blinkInterval, cit1BlinkKonec
	mov blinkInterval, #80
	cpl blinkState
cit1BlinkKonec:
	jb blinkState, cit1PreskocInc
	setb dispDesetiny
	setb dispJednotky
	setb dispDesitky
	sjmp cit1Konec

cit1Dale:
	jnb citani, cit1PreskocInc
	djnz dispInc, cit1PreskocInc
	mov dispInc, #16

	inc desetiny
	cjne desitky, #9, cit1Dale2
	cjne jednotky, #9, cit1Dale2
	cjne desetiny, #9, cit1Dale2
	clr citani
	inc desitky
	inc jednotky
	inc desetiny
	setb blink
	clr zTecka
	sjmp cit1PreskocInc
cit1Dale2:
	cjne desetiny, #10, cit1PreskocInc
	mov desetiny, #0
	inc jednotky
	cjne jednotky, #10, cit1PreskocInc
	mov jednotky, #0
	inc desitky	
cit1PreskocInc:
	push ACC
	jnb dispDesetiny, cit10
	jnb dispJednotky, cit11
	setb dispDesitky
	clr dispDesetiny
	lcall prDispDesetiny
	sjmp cit1POP
cit10:
	setb dispDesetiny
	clr dispJednotky
	lcall prDispJednotky
	sjmp cit1POP
cit11:	
	setb dispJednotky
	clr dispDesitky
	lcall prDispDesitky
	sjmp cit1POP
cit1POP:
	pop ACC
cit1Konec:
	clr RS0
	
	jnb motor, cit1Kon
	lcall prMotor
cit1Kon:
	reti

;;; podprogram pro zobrazeni desetin displeji

prDispDesetiny:
	mov A, desetiny
	movc A, @A+DPTR
	mov P1, A
	ret

;;; podprogram pro zobrazeni jednotek na displeji

prDispJednotky:
	mov A, jednotky
	movc A, @A+DPTR
	jnb zTecka, prDispJednotkyBezTecky ; v modu stopek pridame des. carku
	anl A, #11111101b
prDispJednotkyBezTecky:
	mov P1, A
	ret

;;; podprogram pro zobrazeni desitek na displeji

prDispDesitky: 
	mov A, desitky
	movc A, @A+DPTR
	mov P1, A
	ret

;;; podprogram pro posouvani sviticich LED na portu P2

prPosunuti:
	cjne zaklad, #1, prPosunutiPosun
	mov A, #01111111b 
	sjmp prPosunutiKonec
prPosunutiPosun:
	mov A, zaklad
	clr C
	rrc A
prPosunutiKonec:
	mov zaklad, A
	ret

;;; podprogram pro srovnani pozice rozsvicenych LED po pridani dalsi LED

prSrovnaniPozice:
	mov tmp, pocetRotaci
	cjne pocetRotaci, #0, prSrovnaniPoziceCyklus
	ret
prSrovnaniPoziceCyklus:
	jb smer, prSrovnaniPoziceDoprava
	rl A
	sjmp prSrovnaniPozicePokracuj
prSrovnaniPoziceDoprava:
	rr A
prSrovnaniPozicePokracuj:
	djnz pocetRotaci, prSrovnaniPoziceCyklus
	mov P2, A
	mov pocetRotaci, tmp
	ret

;;; podprogram pro TL2 na zakladni desce

prTlac2:
	inc pocetTlac2
	cjne pocetTlac2, #1, prTlac2Neni1
	mov predvolba, #20
	ret
prTlac2Neni1:
	cjne pocetTlac2, #2, prTlac2Neni2
	mov predvolba, #40
	ret
prTlac2Neni2:
	mov pocetTlac2, #0
	mov predvolba, #10
	cpl smer
	ret

;;; podprogram pro TL1 na desce s displeji

prDTlac1:
	jnb rucniCitani, prDTlac1Inc
	setb RS0
	cjne desetiny, #0, prDTlac1Nulovani
	cjne jednotky, #0, prDTlac1Nulovani
	cjne desitky, #0, prDTlac1Nulovani
	clr RS0
	sjmp prDTlac1Inc
prDTlac1Nulovani:
	mov pocetDTlac1, #0
prDTlac1Inc:
	inc pocetDTlac1
prDTlac1Porovnani:
	cjne pocetDTlac1, #1, prDTlac1Neni1
	setb RS0
	mov desetiny, #0
	mov jednotky, #0
	mov desitky, #0
	clr RS0
	clr zTecka
	clr blink
	setb rucniCitani
	ret
prDTlac1Neni1:
	cjne pocetDTlac1, #2, prDTlac1Neni2
	setb citani
	setb zTecka
	clr rucniCitani
	ret
prDTlac1Neni2:
	clr citani
	mov pocetDTlac1, #0
	ret

;;; podprogram pro TL2 na desce s displeji, mod citace

prPrictiDisp:
	jnb rucniCitani, prPrictiDispKonec
	setb RS0
	inc desetiny
	cjne desitky, #9, prPrictiDispDale
	cjne jednotky, #9, prPrictiDispDale
	cjne desetiny, #9, prPrictiDispDale
	clr rucniCitani
	clr RS0
	mov pocetDTlac1, #0
	setb RS0
	sjmp prPrictiDispKonec
prPrictiDispDale:
	cjne desetiny, #10, prPrictiDispKonec
	mov desetiny, #0
	inc jednotky
	cjne jednotky, #10, prPrictiDispKonec
	mov jednotky, #0
	inc desitky
prPrictiDispKonec:
	clr RS0
	ret

;;; podprogram pro otoceni krokoveho motoru

prMotor:
	setb RS1
	inc motorPocet
	cjne motorPocet, #1, prMotorNeni1
	setb P0.0
	setb P0.1
	sjmp prMotorKonec
prMotorNeni1:
	cjne motorPocet, #2, prMotorNeni2
	clr P0.1
	sjmp prMotorKonec
prMotorNeni2:
	cjne motorPocet, #3, prMotorNeni3
	clr P0.0
	sjmp prMotorKonec
prMotorNeni3:
	mov motorPocet, #0
	setb P0.1
	sjmp prMotorKonec
prMotorKonec:
	clr RS1
	ret

;;; podprogram spozdeni, pouzivan vzdy po stisku tlacitka
;;; osetri zakmity spinacu

prSpozdeni: ; R5-7
	mov R5, #2
	mov R6, #0FFh
	mov R7, #0FFh
pp:
	djnz R7, pp
	djnz R6, pp
	djnz R5, pp
	ret

	end